# ңפȤ by nomonomo
#
# $Id: Client.pm,v 1.8 2005/11/02 07:06:24 white Exp $
#
# ѥå̾ꤹ롣
package ROTool::Ragpos::Client;

# ³ƥ١⥸塼use & Ѿ
use strict;
use ROTool;
use ROTool::Client;
use vars qw(@ISA);
@ISA = qw( ROTool::Client ROTool );

# ץꥱСεҡߤǤɤ
my $APPRI_VER = "Ragpos_0.2";
my $VER29 = 0;

# бMapѡ
my $__job_map_already_read__;
my %job_id2str;
my %job_str2id;

# ɣХɥ쥹
my $__ip_map_already_read__;
my %ip_server2ip;
my %ip_ip2server;


# 饤ȽѤΥ饹᥽åtypechecker
#   typecheckerimportROToolϿ졢
#   ROTool::recv()ƤФ뤳Ȥˤʤ롣
sub typechecker{
    # It's not a method, but method-like callback function.
    # It's called from ROTool::recv().
    my $self = shift;
    if($self->{"buf"} =~ /^L=/){
	bless $self;
	$self->new();
	return 1;
    }else{
	return 0;
    }
}

# Υ⥸塼importtypecheckerϿ롣
sub import{
    my $class = shift;
    # don't delete above line.
    &ROTool::typechecker_regist(\&typechecker);
    if((shift) eq 'ver2.9'){
	$VER29 = 1;
    }else{
	$VER29 = 0;
    }
    print "VER29=$VER29\n";
}

# 󥹥ȥ饯 new
# ROTool::recv()typecheckerȤäƥ饤Ƚ̤Ԥʤ줿塢
# Ŭ礷Ƥ˸ƤФüʥ󥹥ȥ饯
sub new{
    my $self = shift;
    # It's morph-processor method, not a constractor.
    $self = $self->SUPER::new(@_);
    $self->{"param"}->{"APPRI_VER"} = $APPRI_VER;
    $self->{"mapconv"} = $self->{opt}->{MapNameConverter};

    # <->idѴơ֥ɤ߹ߡ
    if(not $__job_map_already_read__
       && defined $self->{opt}->{ragpos_job}){
	open(TABLE,$self->{opt}->{ragpos_job});
	while(<TABLE>){
		chomp();
		if($_)
		{
		    &jcode::convert(\$_,'sjis');
		    my($id,$str) = split('=',$_);
		    if($id =~ /^\d+$/){
			$job_id2str{$id}  = $str;
			$job_str2id{$str} = $id;
	    	}else{
			$job_str2id{$id} = $str;
	    	}
	    }
	}
	$__job_map_already_read__ = 1;
    }

    # ip<->serverѴơ֥ɤ߹ߡ
    if(not $__ip_map_already_read__
	) {
#       && defined $self->{opt}->{ragpos_ip}){
#	open(TABLE,$self->{opt}->{ragpos_ip});
	open(TABLE,"./etc/server_ip.txt");
	while(<TABLE>){
		chomp();
		if($_)
		{
#	    &ROTool::printlog(1,"iplist=" . $_ . "\n");
		    &jcode::convert(\$_,'sjis');
		    my($id,$str) = split('=',$_);
# ζк
		    $id  =~ s/\s*//g;
		    $str =~ s/\s*//g;
#		    if($id =~ /^\d+$/){
			$ip_server2ip{$id}  = $str;
			$ip_ip2server{$str} = $id;
#	    &ROTool::printlog(1,"ip_server2ip[$id] = " . $ip_server2ip{$id} . "=$str\n");
#	    &ROTool::printlog(1,"ip_ip2server[$str] = " . $ip_ip2server{$str} . "=$id\n");
#		    }else{
#			$job_str2id{$id} = $str;
#		    }
		}
	}
	$__ip_map_already_read__ = 1;
    }


    return $self;
}

sub is_client{
    return 1;
}

sub is_server{
    return 0;
}

# åν
#   åβϡUAϿͤμ谷ʤɤԤʤ
#   $self->SUPER::recv() ¹Ԥȡ$self->{buf}˼å롣
#   θβǽѤʬŬڤ˺뤳ȡ
#   ͤϡ̤ʾ$self->SUPER::recv()̤ͤ뤳ȡ
sub recv{
	my($self) = shift;

	my($ret) = $self->SUPER::recv();
	&ROTool::printlog(4," [oid = $self->{oid}] parse message\n");

	while($self->{"buf"} =~ s/L=(\d*)\001?(.*?)\002//){
		my $length = $1;
		my $msg = $2;
		@_ = split(/\001/,$msg);
	
		my $r = $_[1];
	
		splice(@_,0,2);
	
		my $message = $_[0];
		if($message ne $self->{"param"}->{"message"}){
			$self->timestamp();
		}
	
		my @data = @_;

		$r =~ s/^R=(\d).*?/$1/;

		$self->{"param"}->{"r"} = $r;
		if ($self->{"param"}->{"r"} eq "0")
		{
			@{$self->{"param"}}{"id","message"} = @data;
			$self->{"param"}->{"id"} =~ s/^I=(.*)/$1/;
			$self->{"param"}->{"message"} =~ s/^M=(.*)/$1/;

			$self->{"param"}->{"server"}  = "----";
			$self->{"param"}->{"area"}    = "--";
			$self->{"param"}->{"name"}    = "----";
			$self->{"param"}->{"hp"}      = 0;
			$self->{"param"}->{"hpmax"}   = 0;
			$self->{"param"}->{"sp"}      = 0;
			$self->{"param"}->{"spmax"}   = 0;
			$self->{"param"}->{"class"}   = "--";
			$self->{"param"}->{"baselv"}  = "--";
			$self->{"param"}->{"joblv"}   = "--";

			$self->{"param"}->{"weight"}      = 0;
			$self->{"param"}->{"weightmax"}   = 0;
			$self->{"param"}->{"expperhour"}  = 0;
			$self->{"param"}->{"ragpos_version"} = "2.9" if $VER29;
		} else {
	    	@{$self->{"param"}}{"id","message","zeny","exp","expmax",
				"jobexp","jobexpmax","weight","weightmax","baselv",
				"joblv","hp","hpmax","sp","spmax","name","areaname",
				"a1","gameservername","classno"} = @data;
			$self->{"param"}->{"id"} =~ s/^I=(.*)/$1/;
			$self->{"param"}->{"message"} =~ s/^M=(.*)/$1/;
			$self->{"param"}->{"class"} =
				$job_id2str{$self->{"param"}->{"classno"}} || $self->{"param"}->{"classno"};

			if((index $self->{"param"}->{"gameservername"},"/") < 0) {
				$self->{"param"}->{"server"} =
					$ip_ip2server{$self->{"param"}->{"gameservername"}} || "----";
			} else {
				my($server_t,$server_tt) = split('/',$self->{"param"}->{"gameservername"});
				$self->{"param"}->{"server"} =
				$ip_ip2server{$server_t} || "----";
			}

#			餰ݤϥå
			if((index $self->{"param"}->{"exp"},"/") < 0) {
#				
				$self->{"param"}->{"area"} =
					$self->{"mapconv"}->area2name($self->{"param"}->{"areaname"}) || $self->{"param"}->{"areaname"};
				$self->{"param"}->{"ragpos_version"} = "2.0";
			} else {
#				
				$self->{"param"}->{"area"} =
					$self->{"mapconv"}->area2name($self->{"param"}->{"a1"}) || $self->{"param"}->{"a1"};
				$self->{"param"}->{"ragpos_version"} = "2.9";
#				иʬΥ
				$self->{"param"}->{"exp_all"}    = $self->{"param"}->{"exp"};
				$self->{"param"}->{"jobexp_all"} = $self->{"param"}->{"jobexp"};
				my($exp_1,$exp_2)   = split('/',$self->{"param"}->{"exp"});
				$self->{"param"}->{"exp"}        = $exp_1;
				$self->{"param"}->{"expperhour"} = $exp_2;

				my($jexp_1,$jexp_2) = split('/',$self->{"param"}->{"jobexp"});
				$self->{"param"}->{"jobexp"}     = $jexp_1;
			}
		}
	}

	if(&ROTool::UA_regist($self->{"param"}->{"id"},$self) == 0){
		return 0;
	}
    return $ret;
}

# åν
sub send{
    my $self = shift;
    my $count = 0;
    my @msg;

#  å
#    &ROTool::UA_list()ȤäƳƥ饤ȥ֥Ȥ
#    ƥ饤ȤΥǡץȥŬ礷ǡ롣
    foreach my $client(&ROTool::UA_list()){
	# Fetch data from UA_list.
	# and make message send to peer client.
	next if($client->is_client() == 0);
	$count++;
	my %param = %{$client->{param}};
	my @msg_s;

	$param{"r"} ||= defined($param{"r"})?$param{"r"} : 1;
	if ($param{"r"} eq 0 || $param{"baselv"} eq "--" || $param{"baselv"} eq 0)
	{
		push(@msg_s,"R=0","I=" . $param{"id"},"M=" . $param{"message"});
	} else {
		$param{"server"}   ||= "----";
		$param{"hp"}       ||= 0;
		$param{"hpmax"}    ||= 0;
		$param{"sp"}       ||= 0;
		$param{"spmax"}    ||= 0;
		$param{"baselv"}   ||= 0;
		$param{"joblv"}    ||= 0;
		$param{"classno"}  ||= defined($param{"class"})?defined($job_str2id{$param{"class"}}) ? $job_str2id{$param{"class"}} : 0  : 0;
		$param{"zeny"}     ||= 0;
		$param{"exp"}      ||= 0;
		$param{"expmax"}   ||= 0;
		$param{"jobexp"}   ||= 0;
		$param{"jobexpmax"}||= 0;
		$param{"weight"}   ||= 0;
		$param{"weightmax"}||= 0;
		$param{"name"}     ||= "";
		$param{"areaname"} ||= $self->{"mapconv"}->name2area($param{"area"}) || $param{"area"};
		$param{"a1"}       ||= $self->{"mapconv"}->name2area($param{"area"}) || "unknown";
		$param{"gameservername"} ||= $ip_server2ip{$param{"server"}} || "";
		$param{"ragpos_version"} ||= 0;
	
#		餰ݤץȥ Ver2.9ϥå
		if(defined($self->{"param"}->{"ragpos_version"}) 
		   && $self->{"param"}->{"ragpos_version"} eq "2.9")
		{
			#襯饤Ȥ餰ݤץȥ Ver2.9Ϥξ
			if($param{"ragpos_version"} eq "2.9") {
				#ǡ餰ݤץȥ Ver2.9Ϥξ
				push(@msg_s,"R=1","I=" . $param{"id"},"M=" . $param{"message"},
				@param{"zeny","exp_all","expmax","jobexp_all","jobexpmax","weight","weightmax",
				"baselv","joblv","hp","hpmax","sp","spmax","name","areaname","a1",
				"gameservername","classno"});
			} else {
				#ǡ餰ݤץȥ Ver2.9ϰʳξ
				push(@msg_s,"R=1","I=" . $param{"id"},"M=" . $param{"message"},
				@param{"zeny","exp","expmax","jobexp","jobexpmax","weight","weightmax",
				"baselv","joblv","hp","hpmax","sp","spmax","name","areaname","a1",
				"gameservername","classno"});
			}
		} else {
			#襯饤Ȥ餰ݤץȥ Ver2.9ϰʳξ
			if($param{"ragpos_version"} eq "2.9") {
				#ǡ餰ݤץȥ Ver2.9Ϥξ
				#areaname˥ΥݥäƤ뤿
				push(@msg_s,"R=1","I=" . $param{"id"},"M=" . $param{"message"},
				@param{"zeny","exp","expmax","jobexp","jobexpmax","weight","weightmax",
				"baselv","joblv","hp","hpmax","sp","spmax","name","a1","a1",
				"gameservername","classno"});
			} else {
				#ǡ餰ݤץȥ Ver2.9ϰʳξ
				push(@msg_s,"R=1","I=" . $param{"id"},"M=" . $param{"message"},
				@param{"zeny","exp","expmax","jobexp","jobexpmax","weight","weightmax",
				"baselv","joblv","hp","hpmax","sp","spmax","name","areaname","a1",
				"gameservername","classno"});
			}
		}
	}
	my $temp = join("\001",@msg_s);
	$temp = $temp . "\001";
	push(@msg , $temp);
    }
    my @msg_t;
    push(@msg_t,"P=200","V=2.21","C=$count",join("\002",@msg) . "\002");
    my $data_length = length("@msg_t");
    unshift(@msg_t,"L=$data_length");
    
#  å
#    Ǻäå롣
    my $sock = $self->{"sock"};
    my $msg = join("\001",@msg_t);
    $sock->syswrite($msg,length($msg));
    &ROTool::printlog(4,"msg=[$msg]\n");
}


1;
